﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Gifitti
{
    public partial class Form1 : Form
    {
        GifModel gm;

        // GifImage _currentGif; <- used to encapsulate info later 
        private const int widthBuffer = 20;
        private const int heightBuffer = 60;
        Image globalGif;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "GIF Files|*.gif";
            DialogResult result = openFileDialog1.ShowDialog(); // Show the dialog.
            if (result == DialogResult.OK) // Test result.
            {
                string file = openFileDialog1.FileName;
                try
                {

                    gm = new GifModel(file);
                    gm.ReverseAtEnd = false;
                    Image loadedGif = Image.FromFile(file);
                    globalGif = loadedGif;
                    //gifView.Image = loadedGif;

                    gifView.Width = loadedGif.Width;
                    gifView.Height = loadedGif.Height;
                    ClientSize = new Size(loadedGif.Width + widthBuffer, loadedGif.Height + heightBuffer);
                }

                catch (IOException)
                {
                }

                CenterToScreen();

                //Focus the gif:
                gifView.Select();
                gifView.Focus();
                ActiveControl = gifView;

                //Start Animating   
                timer1.Enabled = true;

                //Enable frame selection
                textBox1.Enabled = true;
                textBox2.Enabled = true;
                button3.Enabled = true;

                //set the initial frames in textbox
                textBox1.Text = "0";
                textBox2.Text = gm.numberOfFrames.ToString();
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            String x = "";
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
            {
                x = folderBrowserDialog1.SelectedPath;
            }

            List<Image> IMGs = new List<Image>();
            Image test;
            int Length = globalGif.GetFrameCount(FrameDimension.Time);

            for (int i = 0; i < Length; i++)
            {
                globalGif.SelectActiveFrame(FrameDimension.Time, i);
                test = new Bitmap(globalGif);
                String y = "\\tmp-" + i + ".bmp";
                String xy = x + y;
                test.Save(@xy);

            }
        }

        private Boolean chkImage()
        {
            Boolean check = true;
            try
            {
                int Length = globalGif.GetFrameCount(FrameDimension.Time);
            }
            catch (Exception e)
            {
                check = false;
                MessageBox.Show("Must load a gif before getting output");
            }

            return (check);
        }
        private void menuItem3_Click(object sender, EventArgs e)
        {
            if(chkImage())
            {
                String x = "";
                if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
                {
                    x = folderBrowserDialog1.SelectedPath;
                }
                
                List<Image> IMGs = new List<Image>();
                Image test;
                int Length = globalGif.GetFrameCount(FrameDimension.Time);
                if (x != "")
                {
                    for (int i = 0; i < Length; i++)
                    {
                        globalGif.SelectActiveFrame(FrameDimension.Time, i);
                        test = globalGif;
                        String y = "\\tmpj-" + i + ".jpg";
                        String xy = x + y;
                        test.Save(@xy, ImageFormat.Jpeg);
                    }
                }
            }
           
        }

        private void menuItem4_Click(object sender, EventArgs e)
        {
            if (chkImage())
            {
                String x = "";
                if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
                {
                    x = folderBrowserDialog1.SelectedPath;
                }

                List<Image> IMGs = new List<Image>();
                Image test;
                int Length = globalGif.GetFrameCount(FrameDimension.Time);
                if (x != "")
                {
                    for (int i = 0; i < Length; i++)
                    {
                        globalGif.SelectActiveFrame(FrameDimension.Time, i);
                        test = globalGif;
                        String y = "\\tmpp-" + i + ".png";
                        String xy = x + y;
                        test.Save(@xy, ImageFormat.Png);
                    }
                }
            }
        }

        private void menuItem5_Click(object sender, EventArgs e)
        {
            if (chkImage())
            {
                String x = "";
                if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
                {
                    x = folderBrowserDialog1.SelectedPath;
                }

                List<Image> IMGs = new List<Image>();
                Image test;
                int Length = globalGif.GetFrameCount(FrameDimension.Time);
                if (x != "")
                {
                    for (int i = 0; i < Length; i++)
                    {
                        globalGif.SelectActiveFrame(FrameDimension.Time, i);
                        test = new Bitmap(globalGif);
                        String y = "\\tmpb-" + i + ".bmp";
                        String xy = x + y;
                        test.Save(@xy);
                    }
                }
            }
        }

        private void menuItem6_Click(object sender, EventArgs e)
        {
            if (chkImage())
            {
                String x = "";
                if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
                {
                    x = folderBrowserDialog1.SelectedPath;
                }

                List<Image> IMGs = new List<Image>();
                Image test;
                int Length = globalGif.GetFrameCount(FrameDimension.Time);
                if (x != "")
                {
                    for (int i = 0; i < Length; i++)
                    {
                        globalGif.SelectActiveFrame(FrameDimension.Time, i);
                        test = globalGif;
                        String y = "\\tmpt-" + i + ".tiff";
                        String xy = x + y;
                        test.Save(@xy, ImageFormat.Tiff);
                    }
                }
            }
        }
        private void button3_Click(object sender, EventArgs e)
        {
            if (timer1.Enabled == true)
            {
                button3.Text = "Start";
                gifView.Enabled = false;
                timer1.Enabled = false;
            }
            else
            {
                button3.Text = "Stop";
                gifView.Enabled = true;
                timer1.Enabled = true;
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            //get next frame
            gifView.Image = gm.GetNextFrame();
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            gm.startFrame = int.Parse(textBox1.Text);
        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {
            gm.endFrame = int.Parse(textBox2.Text);
        }
    }
}
